Debian source publication checks have broken

Bug #845487 reported by Colin Watson on 2011-09-09
10
This bug affects 1 person
Affects Status Importance Assigned to Milestone
ubuntu-dev-tools (Ubuntu)
High
Stefano Rivera
Lucid
Medium
Unassigned
Maverick
Medium
Unassigned
Natty
Medium
Unassigned

Bug Description

This morning, the Launchpad developers ran an SQL query to convert Pending source publications in Debian to Published. The reason they were Pending was that the program used to import Debian was the same as that used to initially import Ubuntu into Launchpad, and that initial import needed to set everything to Pending so that the first publisher run would work. However, this was inappropriate for representing the state of the Debian archive, so things are now being changed over to Published. Some newly-created records will still be created as Pending until the next Launchpad deployment.

This change has broken ubuntu-dev-tools, because there are some bits of code that assume that Debian publications will always be Pending and not Published.

Internally, Launchpad has this:

active_publishing_status = (
    PackagePublishingStatus.PENDING,
    PackagePublishingStatus.PUBLISHED,
    )

... and to be honest I think that's probably correct for most of the stuff ubuntu-dev-tools is doing, regardless of whether it's looking at Debian or Ubuntu; it would make ubuntu-dev-tools effectively more responsive if it didn't have to wait for a publisher run before noticing that a package version exists in Ubuntu, for example.

Unfortunately, you can't pass multiple statuses in one API call (bug 845486). I suppose this either leaves us making multiple calls or asking for all statuses and filtering afterwards.

== SRU Justification ==
Breaks anything that looks for Debian source records in launchpad, such as requestsync in --lp mode.

== SRU Test Case ==
Only in maverick or lucid: manage-credentials create -c ubuntu-dev-tools -l 2
Try to sync a package: requestsync --lp ibid
Good: Continues with usual sync process
Bad: E: The package 'ibid' does not exist in the Debian primary archive in 'sid'

Stefano Rivera (stefanor) wrote :

committed the easy s/Pending/Published/ solution (which we should also SRU).

Changed in ubuntu-dev-tools (Ubuntu):
assignee: nobody → Stefano Rivera (stefanor)
importance: Undecided → High
status: New → Fix Committed
Stefano Rivera (stefanor) wrote :

Natty still has an SRU in proposed (LP: #785923), but once it's cleared...

description: updated
Stefano Rivera (stefanor) wrote :
Stefano Rivera (stefanor) wrote :
tags: added: sru

The attachment "natty-proposed.debdiff" of this bug report has been identified as being a patch in the form of a debdiff. The ubuntu-sponsors team has been subscribed to the bug report so that they can review and hopefully sponsor the debdiff. In the event that this is in fact not a patch you can resolve this situation by removing the tag 'patch' from the bug report and editing the attachment so that it is not flagged as a patch. Additionally, if you are member of the ubuntu-sponsors please also unsubscribe the team from this bug report.

[This is an automated message performed by a Launchpad user owned by Brian Murray. Please contact him regarding any issues with the action taken in this bug report.]

tags: added: patch
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubuntu-dev-tools - 0.131

---------------
ubuntu-dev-tools (0.131) unstable; urgency=low

  [ Stefano Rivera ]
  * doc/requestsync.1: Correct default value for REQUESTSYNC_SMTP_SERVER
    (LP: #844992)
  * import-bug-from-debian: Bugs are filed against source packages in Ubuntu.
    (LP: #844734)
  * Debian source publication records are all Published now, not pending
    (LP: #845487)
  * requestsync:
    - Add nice error messages to gpg-signing code, rather than simple
      assertions (LP: #537288)
    - Extract current Ubuntu delta from changelog entries and provide for
      editing (LP: #547925)
  * submittodebian:
    - Don't parse the entire changelog, to avoid bumping into past illegal
      version numbers (LP: #727314)
    - Iterate over changelog blocks rather than using Changelog's private
      _blocks list.
  * LP: #806633:
    - ubuntutools.update_maintainer: Don't use strict changelog parsing
    - sponsor-patch: Perform strict validation on the first changelog entry.
  * setup-packaging-environment:
    - Software Sources isn't on the Administration menu, post Gnome 2
      (LP: #841975)
    - Use apt-get rather than aptitude.
  * Removed get-build-deps, mk-build-deps -ir is equivalent (LP: #158108)
  * ubuntutools.archive:
    - Add quiet option to silence downloading.
    - Use wget-style progress bar (fixed width) (LP: #845787)
  * Bump python-debian B-D and Depends to 0.1.20 for unicode Changelog
    reading.
  * backportpackage: Use absolute path of workdir when test-building.

  [ Colin Watson ]
  * syncpackage: Fix typo.

  [ Benjamin Drung ]
  * ubuntutools/requestsync: Follow PEP 8 naming conventions.

 -- Stefano Rivera <email address hidden> Sat, 10 Sep 2011 16:48:23 +0200

Changed in ubuntu-dev-tools (Ubuntu):
status: Fix Committed → Fix Released
Stefano Rivera (stefanor) wrote :

Uploaded SRUs, they're now pending review.

Changed in ubuntu-dev-tools (Ubuntu Lucid):
importance: Undecided → Medium
Changed in ubuntu-dev-tools (Ubuntu Maverick):
importance: Undecided → Medium
Changed in ubuntu-dev-tools (Ubuntu Natty):
importance: Undecided → Medium
status: New → Fix Committed
Changed in ubuntu-dev-tools (Ubuntu Maverick):
status: New → Fix Committed
Changed in ubuntu-dev-tools (Ubuntu Lucid):
status: New → Fix Committed
Clint Byrum (clint-fewbar) wrote :

Stefano, oddly enough, none of the changes files in your uploads include the Launchpad-Bugs-Fixed section referring to this bug, despite your reference to it being properly formatted... any ideas? Leaving them in the queues for now.

Stefano Rivera (stefanor) wrote :

> any ideas? Leaving them in the queues for now.
Bah, that'd be carelessness on my part when preparing them on a Debian box. If you want to clear them from the queues, I can re-do the uploads.

Excerpts from Stefano Rivera's message of Tue Sep 13 13:39:35 UTC 2011:
> > any ideas? Leaving them in the queues for now.
> Bah, that'd be carelessness on my part when preparing them on a Debian box. If you want to clear them from the queues, I can re-do the uploads.
>

Thought that might be it.

All 3 rejected.. upload and I'll take a look ASAP.

> --
> You received this bug notification because you are a member of Ubuntu
> Stable Release Updates Team, which is subscribed to the bug report.
> https://bugs.launchpad.net/bugs/845487
>
> Title:
> Debian source publication checks have broken
>
> Status in “ubuntu-dev-tools” package in Ubuntu:
> Fix Released
> Status in “ubuntu-dev-tools” source package in Lucid:
> Fix Committed
> Status in “ubuntu-dev-tools” source package in Maverick:
> Fix Committed
> Status in “ubuntu-dev-tools” source package in Natty:
> Fix Committed
>
> Bug description:
> This morning, the Launchpad developers ran an SQL query to convert
> Pending source publications in Debian to Published. The reason they
> were Pending was that the program used to import Debian was the same
> as that used to initially import Ubuntu into Launchpad, and that
> initial import needed to set everything to Pending so that the first
> publisher run would work. However, this was inappropriate for
> representing the state of the Debian archive, so things are now being
> changed over to Published. Some newly-created records will still be
> created as Pending until the next Launchpad deployment.
>
> This change has broken ubuntu-dev-tools, because there are some bits
> of code that assume that Debian publications will always be Pending
> and not Published.
>
> Internally, Launchpad has this:
>
> active_publishing_status = (
>     PackagePublishingStatus.PENDING,
>     PackagePublishingStatus.PUBLISHED,
>     )
>
> ... and to be honest I think that's probably correct for most of the
> stuff ubuntu-dev-tools is doing, regardless of whether it's looking at
> Debian or Ubuntu; it would make ubuntu-dev-tools effectively more
> responsive if it didn't have to wait for a publisher run before
> noticing that a package version exists in Ubuntu, for example.
>
> Unfortunately, you can't pass multiple statuses in one API call (bug
> 845486). I suppose this either leaves us making multiple calls or
> asking for all statuses and filtering afterwards.
>
> == SRU Justification ==
> Breaks anything that looks for Debian source records in launchpad, such as requestsync in --lp mode.
>
> == SRU Test Case ==
> Only in maverick or lucid: manage-credentials create -c ubuntu-dev-tools -l 2
> Try to sync a package: requestsync --lp ibid
> Good: Continues with usual sync process
> Bad: E: The package 'ibid' does not exist in the Debian primary archive in 'sid'
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/ubuntu/+source/ubuntu-dev-tools/+bug/845487/+subscriptions

Stefano Rivera (stefanor) wrote :

Uploaded again yesterday

Benjamin Drung (bdrung) wrote :

Hm, the result of getPublishedSources seems to depend on the API version that is used when login.

For example, you can run this command from trunk:

./sponsor-patch -s 850556

and it will find 0.0+r4091-1.1. But if you add version='devel' to Launchpad.login_with in ubuntutools/sponsor_patch/sponsor_patch.py then it will find 0.0+r4091-1.2.

Stefano Rivera (stefanor) wrote :

> it will find 0.0+r4091-1.1. But if you add version='devel' to
...
> it will find 0.0+r4091-1.2.

0.0+r4091-1.2 appears to still be Pending:
https://launchpad.net/debian/+source/inteltool/+publishinghistory

Hello Colin, or anyone else affected,

Accepted ubuntu-dev-tools into natty-proposed, the package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

tags: added: verification-needed
Clint Byrum (clint-fewbar) wrote :

Hello Colin, or anyone else affected,

Accepted ubuntu-dev-tools into maverick-proposed, the package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Clint Byrum (clint-fewbar) wrote :

Hello Colin, or anyone else affected,

Accepted ubuntu-dev-tools into lucid-proposed, the package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Hey!

Bedankt voor je mail! Ik ben er even tussenuit geknepen naar een lekker warm land! Ik beantwoord je mail na mijn vakantie (11 oktober).

Groetjes!

Ruben

Rolf Leggewie (r0lf) on 2011-10-02
tags: added: verification-done
removed: verification-needed
Ruben (info-rubenfelix) wrote :

Hey!

Bedankt voor je mail! Ik ben er even tussenuit geknepen naar een lekker warm land! Ik beantwoord je mail na mijn vakantie (11 oktober).

Groetjes!

Ruben

Changed in ubuntu-dev-tools (Ubuntu Lucid):
status: Fix Committed → Fix Released
tags: added: verification-needed
tags: added: verification-done-lucid
removed: verification-done
Stefano Rivera (stefanor) wrote :

Verified on natty and maverick, i386.

tags: added: verification-done
removed: verification-done-lucid
tags: removed: verification-done
tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubuntu-dev-tools - 0.104.1

---------------
ubuntu-dev-tools (0.104.1) maverick-proposed; urgency=low

  * Debian source publication records are all Published now, not pending
    (LP: #845487)
 -- Stefano Rivera <email address hidden> Wed, 14 Sep 2011 13:44:46 +0200

Changed in ubuntu-dev-tools (Ubuntu Maverick):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubuntu-dev-tools - 0.122.2

---------------
ubuntu-dev-tools (0.122.2) natty-proposed; urgency=low

  * Debian source publication records are all Published now, not pending
    (LP: #845487)
 -- Stefano Rivera <email address hidden> Wed, 14 Sep 2011 13:45:51 +0200

Changed in ubuntu-dev-tools (Ubuntu Natty):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers